/* ---------------------------------------------------------------------
 * 
 * Giada - Your Hardcore Loopmachine 
 * 
 * ---------------------------------------------------------------------
 * 
 * Copyright (C) 2010-2012 Giovanni A. Zuliani | Monocasual
 * 
 * This file is part of Giada - Your Hardcore Loopmachine.
 * 
 * Giada - Your Hardcore Loopmachine is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * Giada - Your Hardcore Loopmachine is distributed in the hope that it 
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Giada - Your Hardcore Loopmachine. If not, see 
 * <http://www.gnu.org/licenses/>.
 * 
 * ------------------------------------------------------------------ */



#ifndef RECORDER_H
#define RECORDER_H

#include <stdio.h>
#include <stdlib.h>
#include "const.h"
#include "utils.h"
#include "mixer.h"



	

class Recorder {
public:	
	struct _action {
		unsigned chan;
		char     type;
	} action;

	gVector<unsigned>  frames;						
	gVector<_action*>  actions;						
	gVector< gVector<_action*> > global;	

	bool active;	
	bool chanActive[MAX_NUM_CHAN];				
	bool chanEvents[MAX_NUM_CHAN];				

	
	
	void init();

	
	bool canRec(int chan);
	
	
	void rec(unsigned chan, char action, unsigned frame);	
	
	
	void clearChan(unsigned chan);
	
	
	void clearAction(unsigned chan, char action);
	
	
	void clearAll();
	
	
	void optimize();
	
	
	void updateBpm(float oldval, float newval, int oldquanto);
	
	
	void updateSamplerate(int systemRate, int patchRate);
	
	void expand(unsigned old_fpb, unsigned new_fpb);
	void shrink(unsigned new_fpb);
	
	
	void enableRead(int chan);
	void disableRead(int chan);
	
	
	void print();
};

#endif
